﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace WpfApplication1
{
    public partial class MainWindow : Window
    {
        private TcpListener _TcpListener;
        private TcpClient _TcpClient;
        
        private bool _IsRun = false;

        protected NetworkStream _NetStream;

        public MainWindow()
        {
            InitializeComponent();
        }
        
        private void btnListener_Click(object sender, RoutedEventArgs e)
        {
            if (_IsRun)
                return;
            int port = Convert.ToInt32(txtPort.Text.Trim());
            _TcpListener = new TcpListener(new IPEndPoint(IPAddress.Any, port));
            _TcpListener.Start();
            _IsRun = true;

            Print("Listener (" + port + ") was started");

            new Task(() => {
                while (_IsRun)
                {
                    if (_TcpClient == null)
                    {
                        _TcpClient = _TcpListener.AcceptTcpClient();
                        Print("A new connected! remote:" + _TcpClient.Client.RemoteEndPoint.ToString());
                        _NetStream = _TcpClient.GetStream();
                    }
                    if (_TcpClient.Connected && _NetStream.DataAvailable)
                    {
                        byte[] buffer = null;
                        buffer = new byte[_TcpClient.Available];
                        _NetStream.Read(buffer, 0, buffer.Length);
                        string hexString = BitConverter.ToString(buffer, 0, buffer.Length).Replace("-", "");
                        string asciiString = Encoding.ASCII.GetString(buffer, 0, buffer.Length).Trim('\0');
                        Print("HEX:" + hexString + " ASCII:" + asciiString);
                        
                        Analysis(buffer);
                    }
                }
            }).Start();
            
        }

        /// <summary>
        /// Log
        /// </summary>
        /// <param name="msg"></param>
        private void Print(string msg)
        {
            msg = System.DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss ffff") + "： " + msg + "\r";
            this.rtbLog.Dispatcher.Invoke(new Action(() =>
            {
                this.rtbLog.AppendText(msg);
                this.rtbLog.ScrollToEnd();
            }));
        }

        #region
        
        public void Analysis(byte[] data)
        {
            string log = "Analysis error";
            try
            {
                #region AVL05_3g
                //545A005024240153010B0000086383502558636810061C041C0400160000000000000000000000000000000000000000000000060427B60415BB000DAAC0000A37019E055D0000000000000003000B3B0059C0B00D0A
                //string protocols = Encoding.ASCII.GetString(data, 4, 2);
                //if (protocols == "$$")
                //{
                //    TZONE.AVL05_3g.Protocols.Generic generic = new TZONE.AVL05_3g.Protocols.Generic().Analysis(data);
                //    if (generic != null)
                //    {
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //        if (generic.TagList != null && generic.TagList.Count() > 0)
                //        {
                //            log += "\r\n" + "TagList:" + "\r\n";
                //            for (int i = 0; i < generic.TagList.Count; i++)
                //                log += (i + 1) + "、" + "SN:" + generic.TagList[i].SN + "\r\n";
                //        }
                //    }
                //}
                //else if (protocols == "$P")
                //{
                //    TZONE.AVL05_3g.Protocols.Image image = new TZONE.AVL05_3g.Protocols.Image().Analysis(data);
                //    if (image != null)
                //    {
                //        TZONE.AVL05_3g.ImagesHandle imagesHandle = new TZONE.AVL05_3g.ImagesHandle();
                //        imagesHandle.Handle(image);
                //        log = "IMEI：" + image.IMEI + "  " + image.PacketSequenceNumber + "/" + image.TotalPackage + " => Analysis Success";
                //    }
                //}
                #endregion

                #region RD05
                //TZONE.RD05.Protocols.Generic generic = new TZONE.RD05.Protocols.Generic().Analysis(data);
                //if (generic != null)
                //{
                //    log = "IMEI：" + generic.IMEI + " SN：" + generic.SN + " => Analysis Success";
                //    log += "\r Temperature:" + generic.Temperature + " Humidity:" + generic.Humidity;
                //    #region TAG03
                //    //if (generic.Status.Substring(0, 1) == "1")
                //    //    log += " 电池状态：低压";
                //    //else
                //    //    log += " 电池状态：正常";
                //    //if (generic.Status.Substring(1, 1) == "1")
                //    //    log += " 震动状态：是";
                //    //else
                //    //    log += " 震动状态：否";
                //    #endregion

                //}
                #endregion

                #region AVL11
                //TZONE.AVL11.Protocols.Generic generic = new TZONE.AVL11.Protocols.Generic().Analysis(data);
                //if (generic != null)
                //{
                //    log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //    if (!string.IsNullOrEmpty(generic.TagIDList)) 
                //    {
                //        List<TZONE.AVL11.Protocols.TAG> taglist = new TZONE.AVL11.Protocols.TAG().ConvertTag04(generic.TagIDList);
                //        if (taglist != null && taglist.Count() > 0) 
                //        {
                //            foreach (var item in taglist)
                //                log += "\r Temperature:" + item.Temperature + " Humidity:" + item.Humidity;
                //        }
                //    }

                //}


                //TZONE.AVL11.Protocols.Generic generic = new TZONE.AVL11.Protocols.Generic().Analysis(data);
                //if (generic != null)
                //{
                //    log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //    if (!string.IsNullOrEmpty(generic.TagIDList))
                //    {
                //        List<TZONE.AVL11.Protocols.TAG> taglist = new TZONE.AVL11.Protocols.TAG().ConvertTag06(generic.TagIDList);
                //        if (taglist != null && taglist.Count() > 0)
                //        {
                //            foreach (var item in taglist)
                //                log += "\r Temperature:" + item.Temperature + " Humidity:" + item.Humidity;
                //        }
                //    }

                //}
                #endregion

                #region TT11
                //TZONE.TT11.Protocols.Generic generic = new TZONE.TT11.Protocols.Generic().Analysis(data);
                //if (generic != null)
                //{
                //    if (generic != null)
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //}
                #endregion

                #region TT18
                //TZONE.TT18.Protocols.Generic generic = new TZONE.TT18.Protocols.Generic().Analysis(data);
                //if (generic != null)
                //{
                //    if (generic != null)
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //}
                #endregion

                #region AVL19 + TAG06
                //string protocols = Encoding.ASCII.GetString(data, 4, 2);
                //if (protocols == "$$")
                //{
                //    TZONE.AVL19.Protocols.Generic generic = new TZONE.AVL19.Protocols.Generic().Analysis(data);
                //    if (generic != null)
                //    {
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //        List<TZONE.AVL19.Protocols.TAG> tagList = new TZONE.AVL19.Protocols.TAG().ConvertTag06(generic.Tag06List);
                //        if (tagList != null && tagList.Count() > 0)
                //        {
                //            log += "\r\n" + "TagList:" + "\r\n";
                //            for (int i = 0; i < tagList.Count; i++)
                //                log += (i + 1) + "、" + "SN:" + tagList[i].SN + "\r\n";
                //        }
                //    }
                //}
                #endregion

                #region RD06
                //string protocols = Encoding.ASCII.GetString(data, 4, 2);
                //if (protocols == "$$")
                //{
                //    TZONE.RD06.Protocols.Generic generic = new TZONE.RD06.Protocols.Generic().Analysis(data);
                //    if (generic != null)
                //    {
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //        List<TZONE.RD06.Protocols.TAG> tagList = new TZONE.RD06.Protocols.TAG().ConvertTag06(generic.TagList);
                //        if (tagList != null && tagList.Count() > 0)
                //        {
                //            log += "\r\n" + "TagList:" + "\r\n";
                //            for (int i = 0; i < tagList.Count; i++)
                //                log += (i + 1) + "、" + "SN:" + tagList[i].SN + "\r\n";
                //        }
                //    }
                //}
                #endregion

                #region LoRa Gateway
                //string protocols = Encoding.ASCII.GetString(data, 4, 2);
                //if (protocols == "$$")
                //{
                //    TZONE.LoRa.Protocols.Generic generic = new TZONE.LoRa.Protocols.Generic().Analysis(data);
                //    if (generic != null)
                //    {
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //        List<TZONE.LoRa.Protocols.TAG> tagList = new TZONE.LoRa.Protocols.TAG().ConvertTag06(generic.TagList);
                //        if (tagList != null && tagList.Count() > 0)
                //        {
                //            log += "\r\n" + "TagList:" + "\r\n";
                //            for (int i = 0; i < tagList.Count; i++)
                //                log += (i + 1) + "、" + "SN:" + tagList[i].SN + "\r\n";
                //        }
                //    }
                //}
                #endregion

                #region TT11B
                //545A00492424041301000000086706003088782812050E061F0000180112050E061E2C286E3034080F76A4000B007B0000000005000827B612A4046000000009AA20153701950AC6390001433C0D0A 
                //TZONE.TT11B.Protocols.Generic generic = new TZONE.TT11B.Protocols.Generic().Analysis(data);
                //if (generic != null)
                //{
                //    if (generic != null)
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //}
                #endregion

                #region RD06 WiFi
                string protocols = Encoding.ASCII.GetString(data, 4, 2);
                if (protocols == "$$")
                {
                    TZONE.RD06_WiFi.Protocols.Generic generic = new TZONE.RD06_WiFi.Protocols.Generic().Analysis(data);
                    if (generic != null)
                    {
                        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                        log += JsonConvert.SerializeObject(generic);
                        List<TZONE.RD06_WiFi.Protocols.TAG> tagList = new TZONE.RD06_WiFi.Protocols.TAG().ConvertTag06(generic.TagList);
                        if (tagList != null && tagList.Count() > 0)
                        {
                            log += "\r\n" + "TagList:" + "\r\n";
                            for (int i = 0; i < tagList.Count; i++)
                                log += (i + 1) + "、" + "SN:" + tagList[i].SN + " => " + JsonConvert.SerializeObject(tagList[i]) + "\r\n";
                        }
                    }
                }
                #endregion

                #region LoRa WiFi
                //string protocols = Encoding.ASCII.GetString(data, 4, 2);
                //if (protocols == "$$")
                //{
                //    TZONE.LoRa_WiFi.Protocols.Generic generic = new TZONE.LoRa_WiFi.Protocols.Generic().Analysis(data);
                //    if (generic != null)
                //    {
                //        log = "IMEI：" + generic.IMEI + " => Analysis Success";
                //        log += JsonConvert.SerializeObject(generic);
                //        List<TZONE.LoRa_WiFi.Protocols.Sensor> sensorList = new TZONE.LoRa_WiFi.Protocols.Sensor().ConvertSensor(generic.SensorIDList);
                //        if (sensorList != null && sensorList.Count() > 0)
                //        {
                //            log += "\r\n" + "SensorList:" + "\r\n";
                //            for (int i = 0; i < sensorList.Count; i++)
                //                log += (i + 1) + "、" + "SN:" + sensorList[i].SN + " => " + JsonConvert.SerializeObject(sensorList[i]) + "\r\n";
                //        }
                //    }
                //}
                #endregion
            }
            catch (Exception) { }
            Print(log);
        }
        #endregion

    }
}
